<template>
  <el-main>
    <el-row>
      <el-col :sm="{span: 10, offset: 7}" :md="{span: 8, offset: 8}" :lg="{span: 6, offset: 8}">
        <h2>Contact</h2>
        <el-form ref="form_contact" :model="contact" :rules="rules" label-position="top">
          <el-form-item ref="name" prop="name" label="Name" required>
            <el-input v-model="contact.name"></el-input>
          </el-form-item>

          <el-form-item ref="email" prop="email" label="Email" required>
            <el-input v-model="contact.email"></el-input>
          </el-form-item>

          <el-form-item ref="subject" prop="subject" label="Subject" required>
            <el-input v-model="contact.subject"></el-input>
          </el-form-item>

          <el-form-item ref="message" prop="message" label="Message" required>
            <el-input v-model="contact.message" type="textarea"></el-input>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Send message
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
  </el-main>
</template>

<script>
export default {
  data() {
    return {
      contact: {
        name: '',
        email: '',
        subject: '',
        message: ''
      },
      rules: {
        email: { type: 'email' }
      }
    }
  },

  methods: {
    submitForm() {
      let authenticity_token = document.querySelector('meta[name="csrf-token"]').content
      this.$http.post('/contact', { utf8: '✓', authenticity_token: authenticity_token,
                                    contact: this.$refs['form_contact'].model }).then(
        response => {
          this.$msgbox({
            type: 'success',
            message: 'Message sended successfully',
            callback: action => {
              this.$router.push('/')
            }
          })
        },
        response => {
          if(response.body.errors){
            for(let key in response.body.errors) {
              let value = response.body.errors[key]
              if(this.$refs[key])
                this.$refs[key].error = value.join(', ')
            }
          }
      })
    }
  }
}
</script>
